(* program pro vyzkouseni prikazu vstupu a vystupu,
   - nejdrive si program "osahejte" - spustenim, krokovanim,
     zjistenim, co vlastne dela

   - vytvorte si uvodni obrazovku bloku vasich programu.
     Nahradte uvedene vystupy vami zadanymi vstupy (vlastni inicialy apod...)
     nactenymi do znakovych nebo ciselnych promennych (byte, char, string...)
     prikazem read (readln) z klavesnice a zpetne vypsanymi na obrazovku.
     Pripadne promenne nutno nadeklarovat.

   - oramujte hlavni okno nabidnutymi textovymi znaky pro ramecek viz 01- uvod/ascii.pas
     (barvu okna lze pripadne zmenit nastavenim promenne textattr - viz
      priklad color.pas z minuleho cviceni)
     nejlepe pomoci prikazu write uziteho v cyklu - repeat, while, for -
     nebo primym namalovanim ramecku - mene vhodne
      - napoveda : v okne vytvorenem prikazem window je treba 
	- nakreslit nejdriv spodni hranu ramecku (znaky ramecku lze do
	  prikazy write vkladat soucasnym stiskem klavesy alt a cisla 
	  odpovidajiciho ascii hodnote prislusneho znaku)
	- vlozit radek napr. na pozici 1,1 relativne v okne 
	  (prikazy gotoxy(x,y); InsLine; (nebo write(#10) a ramecek dokreslit
        - pro kresleni ramecku s vyhodou vyuzit cyklu for a standardni 
	  procedury GotoXY (help prikazu - kurzor na prikaz + Ctrl+F1)
      - oduvodneni : namalovanim znaku do praveho spodniho rohu okna dojde
                     k odrolovani obsahu okna o radek nahoru
                     => smaze se pripadny obsah prvniho radku
     v programu dodrzte nabidnute pouziti tri prikazu window
     ( hodnoty parametru - veliost okna - muzete volit )
     jinymi slovy pokud vytvarite a popisujete (ramujete) na obrazovce nejake
     okno - nastavujete jeho hodnoty prikazem window - dodrzte pravidlo, ze
     veskere prikazy vztahujici se k tomuto oknu budou nastaveni tohoto
     okna respektovat - pro popis okna nepouzijete dalsi prikaz window.
     Umozni to pozdejsi jednoduche vyuziti tohoto programu pro transformaci
     na proceduru, vytvarejici tzv. plovouci okno - okno s vlastnostmi jake
     maji nabidky menu - lze je vyvolat a smazat.

   - POZNAMKA : pouziti nejruznejsich prikazu skoku kurzoru na danou pozici
                a kombinace prikazu write; writeln; pripadne write(#10)
                - vypis ridiciho znaku - je voleno nahodne ciste pro ilustraci,
                neni nijak sledovana vhodnost jejich uziti.

*)

program vizitka;
uses crt;
var ch : char;
begin TextAttr:=31;                     (* nastaveni barev pisma a pozadi *)
      clrscr;                                           (* vymaz obrazovky *)
      GotoXY(13,2);                                (* skok na danou pozici *)
                               (* - souradnice vuci prave nastavenemu oknu *)
      writeln('cela obrazovka nastavena implicitne po spusteni programu');
      gotoxy(19,wherey);
      writeln('jednotliva okna se nastavuji prikazem window');
      gotoxy(8,wherey+1);
      writeln(' nastaveni barvy pisma a pozadi viz prikazy',
              ' textattr:=31; clrscr;');
      gotoxy(12,wherey);
      writeln('            a program ../01-uvod/color.pas');
      window(15,9,70,19);          (* nastaveni velikosti relativniho okna *)
           (* souradnice jsou udavany vuci cele obrazovce - absolutni okno *)
      textattr:=112;
      clrscr;
      GotoXY(18,1);
      writeln('stin okna, stiskni enter');
      readln;
      window(12,8,68,18);
                   (* nastaveni vnitrniho okna - opet absolutni souradnice *)
      TextAttr:=52;
      clrscr;
      GotoXY(7,2);        (* relativni skok vuci posledne nastavenemu oknu *)
      write('uvodni obrazovka meho zapoctoveho programu',#10,#13);
      gotoxy(26,wherey);
      write(' :-) ');
      writeln;
      writeln('        oramujte nabidnutym rameckem cele okno');
      writeln('                   po vnitrnim okraji');
      GotoXY(26,7);
      write(chr(201),chr(205),chr(205),chr(205),chr(187));
                                           (* namaluje horni radek ramecku *)
      GotoXY(wherex-5,wherey+1); write(chr(186),' ',#1,' ',chr(186));
                                                             (* prostredek *)
      GotoXY(wherex-5,wherey+1);
      write(chr(200),chr(205),chr(205),chr(205),chr(188));
{     alternativne lze psat
      write('','',''); pripadne
      writeln('ͻ');     generovani znaku se provadi soucasnym stiskem
      writeln('   ');     klavesy alt a prislusneho cisla
      writeln('ͼ');      = alt+201
}
      GotoXY(wherex-3,wherey+1);
                                          (* namaluje spodni radek ramecku *)
      ch:=readkey;
         (* ceka na stisk klavesy; jeji ascii hodnotu nacte do promenne ch *)
      window(1,1,80,24);
      TextAttr:=10;
end.
