program Vstupy;
(* varianty vystupu a vstupu retezce, znaku a cisla                        *)
(* prikazy write, writeln read, readln a jejich parametry                  *)

uses Crt;
var ch,z : char;
       w : string;
       s : string[10];
      ss : string[2];
     sss : string[3];
     j,i : byte;
     m,k : integer;
       l : longint;
       r : real;

begin

  TextAttr:=46;                               (* nastaveni barev prostredi *)
  ClrScr;                                               (* vymaz obrazovky *)

(*=========================================================================*)
(* varianty prikazu write, writeln - rozdil mezi nimi                      *)
(*-------------------------------------------------------------------------*)
(* vystup znakoveho retezce *)

  write(' Dobry den svete ! ');                         (* sledovat kurzor *)
  writeln;
  writeln(' Dobry den svete ! ':30);  (* vystup lze formatovat na poc mist *) 
  writeln(' Dobry den svete ! ':3);    (* mensi zadana hodnota se ignoruje *)
                          (* vypis pomoci promenne oriznuti diky deklaraci *)
  s:='Dobry den svete !'; write(' ',s);         (* sledujte polohu kurzoru *)
  writeln;
  writeln(' ',s:5);     (* oriznuti bez ucinku, stejny efekt jak predchozi *)
                                                            (* tri prikazy *)
  writeln('*** ',s,'- svete ! ***');                            (* naprava *)
  writeln;

(* vystup celociselne hodnoty *)
  k:=-456;
  writeln(' ',k);
  TextAttr:=110;
  writeln(k:8);              (* opet lze formatovat pocet zobrazenych mist *)
  TextAttr:=46;                                      (* vhodne pro tabulky *)
  writeln;                                          

(* vystup realneho cisla - nekolik moznych formatu *)
  r:=12345.678;
  writeln(r);        (* bezny vypis *)
  TextAttr:=110;
  writeln(r:12);     (* pocet zobrazenych mist celkem - vcetne desetinnych *)
  TextAttr:=58;
  writeln(r:0:2);    (* obvykly format realneho cisla s danym poctem *)
  TextAttr:=62;      (* desetinnych mist vcetne zaokrouhleni *)
  writeln(r:10:2);   (* pocet zobr. mist celkem ztoho desetinnych *)
  TextAttr:=29;
  writeln(r:15:5);   (* jina varianta *)
  TextAttr:=154;
  writeln(r:8:5);    (* kratsi - spatne zadany format se ignoruje *)
  TextAttr:=46;
  writeln;

(*-------------------------------------------------------------------------*)
(* vystup znaku                                                            *)
(*-------------------------------------------------------------------------*)
(* vsechny pouzitelne znaky v ascii tabulce - viz ascii.pas a preskey.pas  *)
(* znaky s poradovym cislem 0 - 31 - znaky ridici                          *)
(* dve standartni fce - chr(cislo) da znak                                 *)
(*                      ord(znak) da poradove cislo                        *)

  writeln('A');
  z:='A'; writeln(' pismeno ',z);
  z:=#65; writeln(' pismeno ',z);            (* ekvivalentne writeln(#65); *)
  z:=chr(65); writeln(' pismeno ',z);             (* nebo writeln(chr(65); *)
  z:=^A; writeln(' Ctrl+A=',z);   (* nacteni ridiciho znaku odpovidajiciho *)
                                                   (* stisku klaves Ctrl+A *)
  i:=Ord(z); writeln(' Ord(Ctrl+A)=',i);  (* a tisk jeho ordinalni hodnoty *)
  writeln(' ',ord(chr(i)));              (* a zpetne znaku z tabulky Ascii *)

  writeln;

(*-------------------------------------------------------------------------
  na vystup lze poslat i ridici znaky - ascii kod 0 az 31
  -------------------------------------------------------------------------
    tisk znaku s Ascii kodem 13 a 10 - dva nejdulezitejsi ridici znaky
    generovane klavesou enter - #13 - posun kurzoru na zacatek radku,
                              - #10 - posun kurzoru o radek dolu
                                    prepnout do output a sledovat kurzor !
*)
  write(' pozor, v nasledujicim kroku se posune kurzor a text se prepise ! ');
  write(#13);
  write(' Pozor - v nasledujicim kroku se posune radek - PREPSAL SE TEXT ! ');
  z:=#10; write(z);             (* - jaky je rozdil mezi timto a writeln ? *)

  Gotoxy(5,whereY);             (* - co udela tento a dalsi prikazy ?      *)
  write(#10,s);
  write(#10);
  writeln(#7,s,#7);                                   (* pipnuti *)
  writeln;

(*=========================================================================
   PROBLEMATIKA VSTUPU, prikazy read(..); readln(..); - prikazy vstupu
   - read(x); nacteni hodnoty promenne ze vstupu - pouze ji
   - readln(x); nacteni promenne a docteni bufferu vstupu do konce
                (pri vstupu z klavesnice vcetne znaku generovanych klavesou "enter")
   -- pouze jednoduche promenne (ze souboru lze i strukturovane - pozdeji)
*)
  write(' zadej retezec : ');
  readln(w);                   
  writeln(' zadal jsi : ',w);    (* spolecny vypis stejne jako pri vystupu *)

(* ------------------------------------------------------------------------
   najednou lze nacist nekolik promennych ruznych typu,
   - oddelovac pro cisla je mezera,
   - pozor pri nacitani promennych ruznych typu na ekvivalenci deklarovanych
     typu a skutecne zadanych vstupu;
*)
  repeat
    writeln(' zadej na radku postupne ');
    write(' cislo, mezera, znak, retezec tri znaku a cislo : ');
    readln(i,ss,sss,j);
  until i=0;
  writeln;
(* - vysvetlete rozdil mezi zadanym vstupem a deklaraci promennych ss a sss
   - zkuste zadat neco jineho - co se deje a proc
   - doplnte vystup jak cisel tak znaku na tri pozice
*)

(* ________________________________________________________________________
   POZOR NA NEVHODNOU POSLOUPNOST PRIKAZU read(..); .. read(..); readln(..);
   viz ridici znaky generovane klavesou enter a ctene prikazem readln;
   ------------------------------------------------------------------------
  - zapoznamkujte si predchozi text pomoci slozenych zavorek
  - krokujte nasledujici prikazy cyklu repeat se soucasnym zobrazenim
    promennych "s","z" a "w" v okne watches
  - vysvetlete a opravte chyby.
*)

  repeat
    write(' zadej znak nebo retezec : '); read(z); read(w);
    writeln(' zadal jsi  : ',z,' pripadne promennou w : ',w);
    write(' znovu zadej retezec - slovo "konec" ukonci cyklus : ');
    readln(s);             (* v okne watches si zobrazit promenne s a z *)
    writeln(' zadal jsi : ',s);       (* vysvetlit duvod jejich obsahu *)
  until s='konec';

(*-------------------------------------------------------------------------
  pro cisla plati podobne, okrokujte si ve volnem case 
  - zadejte na jednom radku poprve dve cisla oddelena mezerou
  - vysvetlete jak se nacetla druha promenna
    a proc se neprerusil program pro nacteni druheho vstupu
  - opravte chybu

  repeat
    write(' zadej dve cisla oddelena mezerou : '); read(r);
    l:=trunc(r);
    writeln(' prvni cislo jsi zadal : ',l);
    readln(r);
    l:=trunc(r);
    writeln(' druhe cislo jsi zadal : ',l);
  until l=0;
*)

(*-------------------------------------------------------------------------
   objasneni ? - slozitejsi priklad pro pripadne vyuziti rozdilu
                 mezi read a readln
   priklad cte postupne znak po znaku retezec jednorazove zadany na vstupu
   retezec se zadava pri prvnim vykonani prikazu read(z); najednou cely
   priklad precte postupne vsechny znaky, vcetne znaku #13 a #10
   generovanych klavesou enter a vypisuje je na vystup
  -------------------------------------------------------------------------*)
  repeat
    z:=#0;                                                 (* inicializace *)
    write(' zadej libovolny retezec : ');
    while z<>#10 do             (* posledni znak generovany klavesou enter *)
          begin read(z);
                if Ord(z)<32 then write('#',Ord(z))
                             else write(z);
          end;
    writeln(' - toto jsi skutecne zadal!');
    write(' docteno, zmackni klavesu, mezera konci ! ');
    ch:=readkey; if ch=#13 then writeln('enter') else writeln(ch);
  until ch=#32;
  writeln;

(* priklad na cteni vstupu z prikazove radky - command line *)

  writeln(paramcount);
  for i:=0 to ParamCount do
      begin w:=ParamStr(i);
            write(' ',w);
            if ParamCount=0 then writeln(' parametry nezadany ');
      end;
  writeln;
  writeln(' smazat obrazovku ? [A/N] ');
  ch:=readkey; ch:=UpCase(ch);
  if ch='A' then begin TextAttr:=15; clrScr; end;
end.
