 tema : prace s retezcem
 procviceni prikazu case, prace s vyctovym typem a typem interval
 zminene typy vhodne uplatnete v resenych prikladech

 -----------------------
 retezec - posloupnost znaku z ascii tabulky uzavrena do apostrofu
 promenna typu retezec : napr. s='hju8765tyu90-=][4'
 delka retezce - maximalne 256 znaku

 -----------------------
 varianty deklarace :
 type nadpis = string[40];                        (* deklarace typu nadpis *)
 var s : string;                      (* obecny tvar promenne typu retezec *)
    ss : string[20];         (* delku retezce mozno omezit - uspora pameti *)
    nazev : nadpis;      (* promenna nazev typu nadpis=retezec 20-ti znaku *)
    const retez : string[15] = 'toto je retezec';
       (* inicializovana promenna - jeji hodnota je urcena jiz po prekladu *)
 -----------------------
 pouziti : pro nacteni a praci s posloupnosti znaku - jmena, nazvu apod.
 priklad na zaklade predchozi deklarace :
 begin write(' zadej jmeno : '); readln(s); (* na vstupu zadat jmeno+enter *)
       writeln(' zadal jsi toto jmeno : ',s);
 end.
 -----------------------
 moznosti pouziti :
 - delku promenne typu string lze zjistit - viz fce length
 begin s:='dfghjkli9876'; writeln(' retezec ',s,' ma ',length(s),' znaku. ');
 end.

 - s retezcem lze pracovat i znak po znaku (odhadnete, co program dela)
   deklarace viz vyse
 var i : byte;
 begin nazev:=' toto je hlavni program'; i:=2;
       while i<=length(nazev) do
           if nazev[i-1]=' ' then write(Upcase(nazev[i]))
                             else write(nazev[i]);
           i:=i+1;
       readln;
 end.

 - pripadne takto, viz minule cviceni :
  repeat z:=#0; write(' zadej libovolny retezec : ');
    while z<>#10 do 
          begin read(z); if Ord(z)<32 then write('#',Ord(z))
                             	      else write(z);
          end;
    ch:=readkey;
  until ch=#32;

 - nebo lze retezce navzajem spojovat apod.; ostatni viz napoveda
 begin s:='tema dnesniho cviceni';
       ss:='je prace s retezci';
       nazev:=s+' '+ss;
       writeln(nazev);
 end.

 ============================================================================
 ukoly pro pripadnou samostatnou praci :
     - rozmyslet skutecnost, ze diky usporadanosti znaku v ascii tabulce
       lze pomoci fci ord a chr vzajemne prevadet napr mala pismena na velka
       ci z cifry-znaku ziskat cifru-cislo pouhym odectenim poradoveho cisla
       znaku '0' od poradoveho cisla inkriminovaneho znaku
       - napr.: - znak '5' ma poradove cislo ord('5')=53; ord('0')=48;
                - 5=53-48;
     - pisretez.pas pro pripadne testovani a modifikaci dle vlastni volby
 -----------------------
 1.  napiste program, ktery nacte do nejake promenne libovolny retezec
     a obsah teto promenne vypise v opacnem poradi a mala pismena prevede
     na velka a velka pismena na mala
     - viz kostra programu v souboru konverze.pas
 1a. provedte tuto operaci BEZ pouziti promenne pro nacteni
     vstupniho retezce (bez prikazu readln(s); )
 1b. modifikujte ulohu pro test vstupu na vybrane znaky - samohlasky apod.
 -----------------------
 2.  napiste program, ktery zjisti, zda ve vstupu nactenem jako retezec
     libovolnych znaku se vyskytuje cislo a pokud ano, tak toto cislo prevede
     do numericke podoby a vypise, pripadne zjisti jeho ciferny soucet apod.
     napoveda : - na vstupu budu cist znak po znaku cifry z retezce '4567'
                - prectu '4', prevedu '4' na 4,       mam cislo - 4
                - prectu '5', prevedu '5' na 5, potrebuji cislo - 45
                - prectu '6', prevedu '6' na 6, potrebuji cislo - 456
                - ...
 2a. rozmyslete a naprogramujte tyto prevody bez pouziti standardnich
     procedur val s str
     - prevod retezce reprezentujici cele cislo na cislo
     - prevod retezce reprezentujici realne cislo vcetne desetinne casti
       na toto cislo
     - prevod celeho cisla na retezec
     - prevod realneho cisla vcetne desetinne casti na retezec
 2.b napiste program pro prevod vstupniho retezce reprezentujiciho dvojkove 
     (obecne libovolne) cislo na cislo v desitkove soustave
     napoveda : - rozmyslete si podobnost se zadanim z bodu 2
     - rozmyslete modifikaci vstupu pro cislo zadane od nejnizsiho radu 
       (opacne 10 = 0101 ;  6 = 011)
 -----------------------
 3.  napiste program, ktery zjisti, zda zadany vstup je palindrom
     - slovo ctene stejne zepredu i zezadu - kobyla ma maly bok; radar
 -----------------------
 4.  napiste program, ktery nacte do dvou promennych dva rozdilne nahodne
     retezce vyznacujici se lexikografickou usporadanosti svych znaku
     a nasledne tyto dva retezce zatridi do jednoho a ten vytiskne.
     napoveda : - u promenne string se lze ptat zda napr : if 'f'<'K' then ...
                  (jakou pravdivostni hodnotu by mel tento dotaz ?)
                - srovnani se provadi na zaklade velikosti ordinalnich hodnot
		  prislusnych znaku z ascii tabulky
		  (podobne pro libovolny programatorem definovany vyctovy typ)
     - modifikovany algoritmus je pozadovan pro cviceni se soubory
 -----------------------
 5. morseovka - hodne jednouduchy
    - program prevadi vstupni soubor do vystupniho v kodu morseovy abecedy se 
      soucasnym zvukovym vystupem a naopak je schopen precist kod morseovky 
      a zobrazit jej v citelne podobe
    - program je schopen pracovat i se vstupem na prikazove radce
      (napriklad zadam na prikazove radce : vysilej / program pro prevod...apod)
 -------------------------------



 V RAMCI CVICENI VYHLASUJI SOUTEZ :
    - uspeny resitel si muze vybrat k uznani jeden z pozadovanych prikladu
 Zadani : 
    - ci program rozlusti soubor zasifrovany programem kolegy :-) - viz nize
    - nebo :-) ci program vygeneruje za 30 sekund behu programu 
      (zobrazit cas a pocet elementarnich operaci)
      vice palindromu o delce maximalne 60 a 61 znaku (i beze smyslu v cestine)


 ============================================================================


 zapoctovy program - povinne
 ---------------------------
 kryptograficky program 
    - program nacte text ze vstupu do promenne typu string 
    - nasledne provede jakekoliv zakodovani znaku v teto promenne dle libovolne 
      sifry - algoritmu s vypisem zakodovaneho textu na obrazovku
    - nasledne je schopen opetovne zadavany a zakodovany text prevest zpet do citelne podoby
    - veskera cinnost programu bude prehledne zobrazovana na obrazovku
 volitelne parametry :
    - s vyhodou lze pouzit kodovani(iso-latin-2 <=> windows1250, doporucuji vyber rozsirit)
    - program by se mohl pokusit i o nahodne rozlusteni sifry v nahodnem vstupnim
      souboru (zvoleny heuristicky algoritmus budiz ponechan na vasi tvorbe dle 
      vlastniho napadu, ci studia literatury)


