program newton;
uses crt;

var
	a, eps, x, y: real;
	b, i: byte;

begin
	textattr := 15;
	clrscr;

	repeat
		write ('Zadej reálné číslo (0 ukončí): ');
		readln (a);

		if (a > 0) then
		begin
			repeat
				write ('Zadej počet desetinných míst přesnosti výpočtu: ');
				readln (b);
			until b > 0;

			(* Nastavení desetinné přesnosti *)

			eps := 1;

			for i := 1 to b do
				eps := eps / 10;

			(* Výpočet odmocniny Newtonovou metodou *)

			i := 0;
			y := a;

			repeat
				x := y;
				y := (x + a / x) / 2;

				i := i + 1;
			until abs (x - y) < eps;

			(* Výpis *)

			writeln('Druhá odmocnina čísla ', a:10:5, ' je: ', y:0:10);
			writeln('Poslední iterace byla:               ', x:0:10);
			writeln('Zadaná přesnost byla:                ', eps:0:10);
			writeln('Výsledná přesnost je:                ', abs (x - y):0:10);
			writeln(#10, 'Výpočet proběhl v ', i, ' krocích.');

			readkey;
		end;
	until a = 0;
end.