(* 
program pro vypocet druhe odmocniny cisla A pomoci Newtonove metody
verze s pomoci procedury

=> iteracni vzorec 
   x(i+1) = 1/2 (x(i) + A/x(i))  kde i=1,2..  a 
   x(1)   = A    
pro zjednoduseni v iteraci v programu volme x(i+1) = xj  a  x(i) = xi             
vypocet probiha dokud neplati  |xj - xi| < eps - dostatecne male real.c.
*)

uses Crt;
var A : real;
    xi,xj,eps : real;
    z : char;
    i : byte;
procedure Newton(eps,poc : real; var a,b : real; var i : byte);
begin b:=poc; i:=0;
      repeat a := b;
             b := 1/2 * (a + poc/a);
             i := i+1;
      until abs(b-a) < eps;
end;

begin
  TextAttr:=58;                               (* nastaveni barev prostredi *)
  ClrScr;                                               (* vymaz obrazovky *)
  writeln;
  repeat write(' zadej realne cislo pro vypocet odmocniny, nula konci : ');
    readln(A);
    if A>0 then
       begin
         repeat write(' zadej pocet desetinnych mist : '); readln(i);
         until i>0;

         eps:=1;                (* prevedeni eps na pocet desetinnych mist *)
         repeat eps:=eps/10; i:=i-1; until i=0;

         Newton(eps,A,xi,xj,i);
         writeln(' druha odmocnina cisla ',A:10:5,' je : ',xj:0:10);
         writeln(' posledni iterace byla               : ',xi:0:10);
         writeln(' zadana presnost byla                : ',eps:0:10);
         writeln(' vysledna presnost je                : ',xi-xj:0:10);
         writeln(' vypocet probehl v ',i,' krocich');
       end;
  until A=0;
  write(' konec, zmackni klavesu '); z:=readkey;
end.