unit Crt2;

interface

procedure SetCursor(high,low : byte);           (* nastaveni tvaru kurzoru *)
procedure CursOff;                                      (* vypnut kurzoru *)
Procedure CursOn;                                       (* zapnut kurzoru *)
Procedure CursorOn(x,y:byte);                (* zapnut kurzoru v bode x,y *)
procedure SetWin(x1,y1,x2,y2 : byte);                      (* nastavi okno *)
procedure SetWindow(x1,y1,x2,y2,col : byte);  (* nastavi okno vcetne barvy *)

implementation

uses crt, dos;

procedure SetCursor(high,low : byte);
var rg : registers;
begin rg.ah:=$01; rg.cl:=low; rg.ch:=high;
      Intr($10,rg);
end;

procedure CursOff;                                      (* vypnut kurzoru *)
begin SetCursor($20,$20);
end;

Procedure CursOn;                                       (* zapnut kurzoru *)
begin SetCursor(6,7);
end;

Procedure CursorOn(x,y:byte);      (* zapnut kurzoru v bod x,y pozor !!! *)
var Rg: registers;          (* - nerespektuje nastaveni oken pomoci window *)
begin rg.ah:=$02; rg.bh:=0; rg.dl:=x-1; rg.dh:=y-1; Intr($10,Rg);
      SetCursor(6,7); 
end;

procedure SetWin(x1,y1,x2,y2 : byte);
var i : byte;                  (* nastavi okno dane velikosti s oramovanim *)
begin window(x1,y1,x2,y2); ClrScr; x2:=x2-x1+1; y2:=y2-y1+1;
      GotoXY(1,y2); write(#200);             (* posledni radek vcetne rohu *)
      for i:=2 to x2-1 do write(#205);   write(#188);

      GotoXY(1,1); insline; write(#201);        (* prvni radek vcetne rohu *)
      for i:=2 to x2-1 do write(#205);   write(#187);
      for i:=2 to y2-1 do                                    (* prostredek *)
        begin GotoXY(1,i); write(#186); GotoXY(x2,i); write(#186);
        end;
      window(x1+1,y1+1,x1+x2-2,y1+y2-2);         (* nastaveni vnitrku okna *)
      ClrScr; CursOn;
end;

procedure SetWindow(x1,y1,x2,y2,col : byte);  (* nastavi okno vcetne barvy *)
begin TextAttr:=col; SetWin(x1,y1,x2,y2);
end;

end.