(*
=============================================================================
dnesni tema : operace s maticemi
	- program na nasobeni matic nasobmat.pas prepsat s pouzitim unity 
	  s procedurami pro nacteni, vypis a vynasobeni zadanych matic dle 
	  nasledujiciho schematu;
	- dle schematu v souboru winograd.pas napsat proceduru pro nasobeni 
	  matic winogradovou metodou, zaclenit ji do unity a demonstrovat jeji
	  funkci v nejakem programu
------------------------------------------------------------------------------
*)

(* schema programu pro praci s maticemi *)

program Nasobeni_matic;
uses matice; 	
    (* programova jednotka s deklarovanymi typy a procedurami pro praci s maticemi *)

const max = 20;
type rozsah = 1..max;

var m,n,p : rozsah;
   nahoda : boolean; 	(* pomocna promenna, urcujici nacitani matice z klavesnice *) 
			(* nebo pomoci generatoru nahodnych cisel *)

(* deklarace promennych typu matice vyuzivajici typu z programove jednotky matice *)

    z : char;

begin
  repeat write(' zadej typ matice A = [m x n]; m=0 konci program : ');
         readln(m,n); nahoda:=true; 
         CtiMatici(A,m,n,nahoda);
         writeln(' matice A vypada takto : ',#10);
         PisMatici(A,m,n);
         write(#10,' zadej p - typ matice B; B musi byt [',n,' x p] : ');
         readln(p);
         CtiMatici(B,n,p,nahoda);
         writeln(' matice B vypada takto : ',#10);
         PisMatici(B,n,p);
         NasobMatice(A,B,C,m,n,p);     (* provadi A[mxn] x B[nxp] = C[mxp] *)
         writeln(' vysledna matice C[',m,' x ',p,'] vypada takto : ',#10);
         PisMatici(C,m,p);
(* -------  co by udelala posloupnost prikazu : --------- *)
         NasobMatice(A,B,A,m,n,p);
         PisMatici(C,m,p);
         PisMatici(A,m,p);
         PisMatici(A,m,n);
(* ------------------------------------------------------ *)
  until (m=0);
end.

=============================================================================
dale winogradova metoda viz soubor winograd.pas

=============================================================================
navrh na zapoctovy program pro operace s maticemi :
musi umet :
     - bezne operace : scitani, odcitani, nasobeni,
     - na zaklade linearni algebry hledani matice inverzni + kontrola vysledku
       - Gaussova eliminacni metoda nebo jina =>
     - "deleni matic" A/B - vyuziti predchoziho bodu
       - nasobeni matice A s matici inverzni k B
     - hledani matice transponovane
     - praci se soubory - ukladani a nacitani vstupnich a vystupnich
       hodnot na disk v libovolnem formatu (textovy nebo typovy soubor)
     - prijemne uzivatelske prostredi
     ----------------------------------------------------------
     - navic by na zaklade predchoziho mohl umet resit soustavu
       linearnich rovnic
     - dalsi dle linearni algebry a vlastni volby

