unit Dynproc;

interface
(*
type typk = byte;
type typk = char;
type typk = integer;
type typk = record st : string; x : byte; end;

dle typu hodnoty ukladane do dynamickych struktur v hlavnim programu
nutno nastavit prislusny typ klice a hodnotu constanty nula
viz :

type typk = word;
const nula = 0;
*)
type typk = string;
const nula : typk = '';

type dynprm = ^prvek;
      prvek = record klic : typk;
                     nasl : dynprm;
              end;

type zasobnik = dynprm;

type fronta = record celo, konec : dynprm;
              end;

var dz : zasobnik;
    df : fronta;
   pom : dynprm;

procedure InitZ(var dz : zasobnik);
procedure UlozVrch(prvek : typk; var dz : zasobnik);
function PrazdnyZ(dz : zasobnik) : boolean;
procedure OdeberCelo(var prvek : typk; var celo : dynprm);
procedure InitF(var df : fronta);
procedure PridejKonec(prvek : typk; var df : fronta);
function PrazdnaF(df : fronta) : boolean;

implementation

procedure InitZ(var dz : zasobnik);
begin dz:=nil;
end;

procedure UlozVrch(prvek : typk; var dz : zasobnik);
var pp : dynprm;
begin new(pp); pp^.klic:=prvek; pp^.nasl:=dz; dz:=pp;
end;

function PrazdnyZ(dz : zasobnik) : boolean;
begin PrazdnyZ:=dz=nil;
end;

procedure OdeberCelo(var prvek : typk; var celo : dynprm);
var pom : dynprm;
begin prvek:=celo^.klic;
      pom:=celo;
      celo:=celo^.nasl;
      dispose(pom);
end;

procedure Nuluj(var ukaz : dynprm);
begin ukaz^.klic:=nula;
      ukaz^.nasl:=nil;
end;

procedure InitF(var df : fronta);             (* => nastavi celo^.klic:=0; *)
begin new(df.konec); Nuluj(df.konec); df.celo:=df.konec; (* celo^.nasl:=nil; *)
end;

procedure PridejKonec(prvek : typk; var df : fronta);
begin with df do begin konec^.klic:=prvek; new(konec^.nasl);
                       konec:=konec^.nasl; Nuluj(df.konec);
                 end;
end;

function PrazdnaF(df : fronta) : boolean;
begin PrazdnaF:=df.celo=df.konec;
end;


end.

