(* 
   program vyhodnocuje postfixovy vyraz ulozeny v textovem souboru 
   postfix.dta pomoci zasobniku 

   priklad infixoveho zapisu s uzarkovanim  -       (4 * (3 - 1)) + 5)
   stejny vyraz v postfixove notaci -                4 3 1 - * 5 +

   v tomto pripade se na zasobnik ukladaji pouze ciselne hodnoty
   je proto vhodne prelozit unitu dynproc.pas s nasledujicimi typy :
   type typk = real;
   const nula : 0;
*)

program spocti;
uses crt, dynproc;
type retez=string[80];
var p,q,r : typk;
     hodn : typk;
        z : zasobnik;
    postf : retez;
        i : byte;
     znak : char;
        f : text;

function cislice(znak : char) : boolean;
begin cislice:=znak in ['0'..'9']
end;

function operator(znak:char):boolean;
begin operator:=znak in  ['+','-','*','/']
end;

begin assign(f,'POSTFIX.DTA'); reset(f); readln(f,postf); close(f);
  writeln(' delka retezce : ',length(postf),' znaku ');
  i:=0; InitZ(z);
  repeat i:=i+1; znak:=postf[i];
   if cislice(znak) then           (* prevedeni nacitanych cifer 
      viceciferneho cisla na cislo a ulozeni hodnoty na zasobnik *)
      begin hodn:=0;
            repeat (*
		   - dle hodnoty znak aktualizuj promennou hodn 
		   - dal nacitej cifry dokud neni mezera
                   *)
            until znak=' ';					(*
            - vyslednou hodnotu uloz na zasobnik, pripadne vypis *)
      end else
      if operator(znak) then
        begin (* 
		- odeber dva prvky zasobniku do promennych p,q
                - a dle operatoru proved operaci
              *)
          case znak of
           '+': r:=p+q;
           '-': r:=p-q;
           '*': r:=p*q;
           '/': r:=p/q
          end;						(*
          - vysledek uloz na zasobnik a vypis na vystup	*)
        end
  until je docteny postf
  writeln('Hodnota je: ', r:10:2);
  repeat until keypressed
end.
